subroutine wrt_mvmc(nkb1,nkb2,nkb3,NTK,Na1,Na2,Na3,n_occ,cut,HR) 
implicit none 
integer::nkb1,nkb2,nkb3,NTK,Na1,Na2,Na3,n_occ 
real(8)::cut 
integer::L1,L2,L3,Nsite 
integer::ia1,ia2,ia3,ja1,ja2,ja3,t1,t2,t3,isite,jsite,ib,jb,i,j,k 
complex(8)::HR(n_occ,n_occ,-Na1:Na1,-Na2:Na2,-Na3:Na3)
complex(8),allocatable::H2D(:,:,:,:) 
real(8)::en,en_abs!20171107 chcke misawa 
real(8),parameter::au=27.21151d0
!--
L1=nkb1
L2=nkb2
L3=nkb3
Nsite=NTK 
allocate(H2d(n_occ,n_occ,Nsite,Nsite)) 
!--
if(mod(Nsite,2)==0)then!even 
 write(6,*)'Nsite even'
 do ia1=-Na1+1,Na1
  do ia2=-Na2+1,Na2
   do ia3=-Na3+1,Na3 
    isite=(ia3+Na3-1)+(ia2+Na2-1)*L3+(ia1+Na1-1)*L3*L2+1 
    do ja1=-Na1+1,Na1
     do ja2=-Na2+1,Na2
      do ja3=-Na3+1,Na3 
       jsite=(ja3+Na3-1)+(ja2+Na2-1)*L3+(ja1+Na1-1)*L3*L2+1  
       t1=ja1-ia1
       t2=ja2-ia2 
       t3=ja3-ia3 
       call rwindvec_even(t1,Na1,L1)
       call rwindvec_even(t2,Na2,L2)
       call rwindvec_even(t3,Na3,L3)
       H2d(:,:,isite,jsite)=HR(:,:,t1,t2,t3)   
      enddo 
     enddo 
    enddo 
   enddo 
  enddo 
 enddo 
else!odd
 write(6,*)'Nsite odd'
 do ia1=-Na1,Na1
  do ia2=-Na2,Na2
   do ia3=-Na3,Na3 
    isite=(ia3+Na3)+(ia2+Na2)*L3+(ia1+Na1)*L3*L2+1 
    do ja1=-Na1,Na1
     do ja2=-Na2,Na2
      do ja3=-Na3,Na3 
       jsite=(ja3+Na3)+(ja2+Na2)*L3+(ja1+Na1)*L3*L2+1  
       t1=ja1-ia1
       t2=ja2-ia2 
       t3=ja3-ia3 
       call rwindvec_odd(t1,Na1,L1)
       call rwindvec_odd(t2,Na2,L2)
       call rwindvec_odd(t3,Na3,L3)
       H2d(:,:,isite,jsite)=HR(:,:,t1,t2,t3)   
      enddo 
     enddo 
    enddo 
   enddo 
  enddo 
 enddo 
endif 
!--
k=0 
do isite=1,Nsite
 do ib=1,n_occ 
  i=ib+(isite-1)*n_occ 
  do jsite=1,Nsite 
   do jb=1,n_occ 
    j=jb+(jsite-1)*n_occ 
    if(i>=j)cycle
    en_abs=abs(H2d(ib,jb,isite,jsite))!20171107 chcke misawa  
    if(en_abs<cut)cycle!20171107 chcke misawa 
    k=k+1
   enddo!jb 
  enddo!jsite 
 enddo!ib
enddo!isite  
!--
!OPEN(500,W,FILE='./dir-mvmc/zHund.def') 
OPEN(500,FILE='zHund.def') 
write(500,'(a30)')'=============================='
write(500,'(a5,i25)')'NHund',k
write(500,'(a30)')'=============================='
write(500,'(a10,f10.5,a10)')'=== Jcut >',cut*au,'eV ======='
write(500,'(a30)')'=============================='
do isite=1,Nsite
 do ib=1,n_occ 
  i=ib+(isite-1)*n_occ 
  do jsite=1,Nsite 
   do jb=1,n_occ 
    j=jb+(jsite-1)*n_occ 
    if(i>=j)cycle
    en=dble(H2d(ib,jb,isite,jsite))!20171107 chcke misawa  
    en_abs=abs(H2d(ib,jb,isite,jsite))!20171107 chcke misawa 
    if(en_abs<cut)cycle!20171107 chcke misawa 
    write(500,'(2i5,2f15.10)') i-1,j-1,en*au!20171107 chcke misawa 
   enddo!jb 
  enddo!jsite 
 enddo!ib
enddo!isite  
close(500) 
!--
!OPEN(01,W,FILE='./dir-mvmc/zExchange.def') 
OPEN(501,FILE='zExchange.def') 
write(501,'(a30)')'=============================='
write(501,'(a9,i21)')'NExchange',k
write(501,'(a30)')'=============================='
write(501,'(a10,f10.5,a10)')'=== Jcut >',cut*au,'eV ======='
write(501,'(a30)')'=============================='
do isite=1,Nsite
 do ib=1,n_occ 
  i=ib+(isite-1)*n_occ 
  do jsite=1,Nsite 
   do jb=1,n_occ 
    j=jb+(jsite-1)*n_occ 
    if(i>=j)cycle
    en=dble(H2d(ib,jb,isite,jsite))!20171107 chcke misawa  
    en_abs=abs(H2d(ib,jb,isite,jsite))!20171107 chcke misawa 
    if(en_abs<cut)cycle!20171107 chcke misawa 
    write(501,'(2i5,2f15.10)') i-1,j-1,en*au!20171107 chcke misawa 
   enddo!jb 
  enddo!jsite 
 enddo!ib
enddo!isite  
close(501) 
!--
k=0 
do isite=1,Nsite
 do ib=1,n_occ 
  i=ib+(isite-1)*n_occ 
  do jsite=1,Nsite 
   do jb=1,n_occ 
    j=jb+(jsite-1)*n_occ 
    if(j==i)cycle
    en_abs=abs(H2d(ib,jb,isite,jsite))!20171107 chcke misawa  
    if(en_abs<cut)cycle!20171107 chcke misawa 
    k=k+1
   enddo!jb 
  enddo!jsite 
 enddo!ib
enddo!isite  
!--
!OPEN(502,W,FILE='./dir-mvmc/zPairhop.def') 
OPEN(502,FILE='zPairHop.def') 
write(502,'(a30)')'=============================='
write(502,'(a8,i22)')'NPairhop',k
write(502,'(a30)')'=============================='
write(502,'(a10,f10.5,a10)')'=== Jcut >',cut*au,'eV ======='
write(502,'(a30)')'=============================='
do isite=1,Nsite
 do ib=1,n_occ 
  i=ib+(isite-1)*n_occ 
  do jsite=1,Nsite 
   do jb=1,n_occ 
    j=jb+(jsite-1)*n_occ 
    if(j==i)cycle 
    en=dble(H2d(ib,jb,isite,jsite))!20171107 chcke misawa  
    en_abs=abs(H2d(ib,jb,isite,jsite))!20171107 chcke misawa  
    if(en_abs<cut)cycle!20171107 chcke misawa 
    write(502,'(2i5,2f15.10)') i-1,j-1,en*au!20171107 chcke misawa  
   enddo!jb 
  enddo!jsite 
 enddo!ib
enddo!isite  
close(502) 
!--
deallocate(H2d) 
return 
end 
!
subroutine rwindvec_odd(t,N,L)
implicit none 
integer::t,N,L
if(t<-N) t=t+L 
if(t> N) t=t-L 
return
end 
!
subroutine rwindvec_even(t,N,L)
implicit none 
integer::t,N,L
if(t<-N+1) t=t+L 
if(t> N) t=t-L 
return
end 

program mksupercell !by Kazum NAKAMURA 
implicit none 
real(8),parameter::pi=DACOS(-1.0d0)
integer,parameter::nx=2 
integer,parameter::ny=2 
integer,parameter::nz=2 
integer,parameter::nxyz=nx*ny*nz 
character(2),allocatable::kdp(:)!kd(NTA)
character(2),allocatable::kd(:)!kd(nxyz*NTA)
real(8),allocatable::xp(:),yp(:),zp(:)!xp(NTA),yp(NTA),zp(NTA)  
real(8),allocatable::x(:),y(:),z(:)!x(nxyz*NTA),y(nxyz*NTA),z(nxyz*NTA)  
integer::NTA
real(8)::a1(3),a2(3),a3(3),alat,talat 
integer::i,j,n,ip,il,jl,kl  
real(8)::R_MIN,R,a,b,c,beta  
!--
read(100,*) alat 
read(100,*) a1(1),a1(2),a1(3)
read(100,*) a2(1),a2(2),a2(3)
read(100,*) a3(1),a3(2),a3(3)
read(100,*) NTA
allocate(kdp(NTA))
allocate(xp(NTA)) 
allocate(yp(NTA)) 
allocate(zp(NTA)) 
!--
do i=1,NTA
 read(100,*) kdp(i),xp(i),yp(i),zp(i) 
enddo 
!--
xp(:)=xp(:)/dble(nx) 
yp(:)=yp(:)/dble(ny) 
zp(:)=zp(:)/dble(nz) 
!--
allocate(kd(nxyz*NTA))
allocate(x(nxyz*NTA)) 
allocate(y(nxyz*NTA)) 
allocate(z(nxyz*NTA)) 
!--
do kl=1,nz
 do jl=1,ny
  do il=1,nx
   do i=1,NTA
    ip=i+(il-1)*NTA+(jl-1)*NTA*nx+(kl-1)*NTA*nx*ny 
    x(ip)=xp(i)+dble(il-1)/dble(nx) 
    y(ip)=yp(i)+dble(jl-1)/dble(ny) 
    z(ip)=zp(i)+dble(kl-1)/dble(nz) 
    kd(ip)=kdp(i)
   enddo 
  enddo 
 enddo 
enddo 
!--
write(6,'(f15.10)') alat 
write(6,*) a1(1)*dble(nx),a1(2)*dble(nx),a1(3)*dble(nx)
write(6,*) a2(1)*dble(ny),a2(2)*dble(ny),a2(3)*dble(ny)
write(6,*) a3(1)*dble(nz),a3(2)*dble(nz),a3(3)*dble(nz) 
write(6,*) NTA*nxyz 
do i=1,NTA*nxyz 
 write(6,'(a5,3f15.10)') kd(i),x(i),y(i),z(i) 
enddo 
!--
STOP
END  

subroutine est_NTK(N,SK,NTK,nkb1,nkb2,nkb3)  
implicit none 
integer::N,nkb1,nkb2,nkb3,NTK  
real(8)::SK(3,N) 
integer::i 
real(8)::x 
!---
x=1.0d0 
do i=1,N
 if(abs(SK(1,i))<1.0d-7) cycle 
 if(abs(SK(1,i))<x) then 
  x=abs(SK(1,i))  
 endif 
enddo    
nkb1=nint(1.0d0/x)  
!---
x=1.0d0 
do i=1,N
 if(abs(SK(2,i))<1.0d-7) cycle 
 if(abs(SK(2,i))<x) then 
  x=abs(SK(2,i))  
 endif 
enddo    
nkb2=nint(1.0d0/x)  
!---
x=1.0d0 
do i=1,N
 if(abs(SK(3,i))<1.0d-7) cycle 
 if(abs(SK(3,i))<x) then 
  x=abs(SK(3,i))  
 endif 
enddo    
nkb3=nint(1.0d0/x)  
!---
NTK=nkb1*nkb2*nkb3 
!write(6,'(a24,4i10)') 'nkb1,nkb2,nkb3,NTK=',nkb1,nkb2,nkb3,NTK  
!---
return 
end 

subroutine wrt_frmsf(NTB,NTK,nkb1,nkb2,nkb3,E_EIG,SK0,FermiEnergy,b1,b2,b3)                     
implicit none 
integer::NTB,NTK,nkb1,nkb2,nkb3 
real(8)::E_EIG(NTB,NTK)           
real(8)::SK0(3,NTK)           
integer::index_kpt(nkb1,nkb2,nkb3) 
integer::ib,ik,ikb1,ikb2,ikb3
real(8)::FermiEnergy,b1(3),b2(3),b3(3)
real(8)::E_3D(nkb3,nkb2,nkb1,NTB) 
integer::fo,ishift  
index_kpt=0     
E_3D=0.0d0 
call make_index_kpt(NTK,nkb1,nkb2,nkb3,SK0(1,1),index_kpt(1,1,1)) 
do ib=1,NTB 
 do ikb1=1,nkb1
  do ikb2=1,nkb2
   do ikb3=1,nkb3 
    ik=index_kpt(ikb1,ikb2,ikb3)
    E_3D(ikb3,ikb2,ikb1,ib)=E_EIG(ib,ik)-FermiEnergy 
   enddo 
  enddo 
 enddo 
enddo 
!---
ishift=0 
fo=301
OPEN(fo,FILE='./dir-wan/dat.frmsf') 
rewind(fo) 
write(fo,*) nkb1,nkb2,nkb3
write(fo,*) ishift!not grid shift
write(fo,*) NTB 
write(fo,*) real(b1(1:3))
write(fo,*) real(b2(1:3))
write(fo,*) real(b3(1:3))
do ib=1,NTB 
 do ikb1=1,nkb1
  do ikb2=1,nkb2
   do ikb3=1,nkb3
    write(fo,*) real(E_3D(ikb3,ikb2,ikb1,ib))
   end do
  end do
 end do
end do
do ib=1,NTB
 do ikb1=1,nkb1
  do ikb2=1,nkb2
   do ikb3=1,nkb3
    write(fo,*) real(ib)!real(phys(ikb3,ikb2,ikb1,ib))
   end do
  end do
 end do
end do
close(fo)
return
end
!---
      SUBROUTINE make_index_kpt(NTK,nkb1,nkb2,nkb3,SK0,index_kpt)      
      implicit none 
      integer::NTK,nkb1,nkb2,nkb3
      real(8)::SK0(3,NTK)  
      integer::ik,ix,iy,iz
      real(8)::x,y,z
      integer::index_kpt(nkb1,nkb2,nkb3)    
 
      if(MOD(NTK,2)/=0) then 
!      write(6,*)'i am in make_index for odd'
       do ik=1,NTK 
        x=SK0(1,ik)*dble(nkb1) 
        y=SK0(2,ik)*dble(nkb2)
        z=SK0(3,ik)*dble(nkb3)  
        x=x+(dble(nkb1)-1.0d0)/2.0d0 
        y=y+(dble(nkb2)-1.0d0)/2.0d0
        z=z+(dble(nkb3)-1.0d0)/2.0d0 
        ix=idnint(x)+1
        iy=idnint(y)+1
        iz=idnint(z)+1
        index_kpt(ix,iy,iz)=ik
!        write(6,*) ix,iy,iz
       enddo 
      else!20170316 
!      write(6,*)'i am in make_index for even'
       do ik=1,NTK 
!       x=SK0(1,ik)*2.0D0*dble(nkb1)+1.0D0  
!       y=SK0(2,ik)*2.0D0*dble(nkb2)+1.0D0  
!       z=SK0(3,ik)*2.0D0*dble(nkb3)+1.0D0  
!       x=(x+dble(nkb1))/2.0D0 
!       y=(y+dble(nkb2))/2.0D0 
!       z=(z+dble(nkb3))/2.0D0 
!       ix=idnint(x)
!       iy=idnint(y)
!       iz=idnint(z)
        x=SK0(1,ik)*dble(nkb1) 
        y=SK0(2,ik)*dble(nkb2)
        z=SK0(3,ik)*dble(nkb3)  
        x=x+dble(nkb1)/2.0d0 
        y=y+dble(nkb2)/2.0d0
        z=z+dble(nkb3)/2.0d0 
        ix=idnint(x)
        iy=idnint(y)
        iz=idnint(z)
        index_kpt(ix,iy,iz)=ik
!       write(6,*) ix,iy,iz
       enddo 
      endif 
!--
!      do iz=1,nkb3 
!       do iy=1,nkb2
!        do ix=1,nkb1
!         ik=index_kpt(ix,iy,iz)
!         write(6,'(i8,3f15.10)') ik,SK0(:,ik)
!        enddo
!       enddo
!      enddo
!      write(6,*)'finish make_index_kpt'
!--
      RETURN  
      END 

!--
      call make_KG0(NTG,b1(1),b2(1),b3(1),Gcut_for_psi,ktmp(1),ktmp(2),ktmp(3),KGtmp(1,1),NG_for_psi)
!--
      subroutine make_KG0(NTG,b1,b2,b3,Gcut,q1,q2,q3,KG0,NG) 
      implicit none 
      integer,intent(in)::NTG
      real(8),intent(in)::b1(3),b2(3),b3(3) 
      real(8),intent(in)::Gcut,q1,q2,q3        
      integer,intent(out)::KG0(3,NTG),NG 
      integer::ig,igL,igL1,igL2,igL3
      real(8)::qgL(3),qgL2  
      integer,parameter::NGL1=50
      integer,parameter::NGL2=50 
      integer,parameter::NGL3=50

      igL=0
      do igL1=-NGL1,NGL1 
       do igL2=-NGL2,NGL2 
        do igL3=-NGL3,NGL3 
         qgL(:)=(q1+dble(igL1))*b1(:)+(q2+dble(igL2))*b2(:)+(q3+dble(igL3))*b3(:)    
         qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
         if(qgL2<=Gcut) then 
          igL=igL+1 
          KG0(1,igL)=igL1
          KG0(2,igL)=igL2
          KG0(3,igL)=igL3 
         endif  
        enddo 
       enddo 
      enddo 
      NG=igL 
      RETURN 
      END 
!---
